package me.mrletsplay.nojs.action;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;

public class ActionData {

	public static final ActionData EMPTY_DATA = new ActionData(Collections.emptyMap());

	private Map<String, String> data;

	private ActionData(Map<String, String> data) {
		this.data = data;
	}

	public ActionData() {
		this.data = new HashMap<>();
	}

	public ActionData put(String key, String value) {
		Objects.requireNonNull(key, "key");
		Objects.requireNonNull(value, "value");

		data.put(key, value);
		return this;
	}

	public List<HtmlElement> createFormElements() {
		if(data.isEmpty()) return Collections.emptyList();

		List<HtmlElement> elements = new ArrayList<>();
		for(Map.Entry<String, String> d : data.entrySet()) {
			HtmlElement e = HtmlElement.of("input");
			e.setAttribute("name", d.getKey());
			e.setAttribute("value", d.getValue());
			e.setAttribute("hidden");
			elements.add(e);
		}

		return elements;
	}

}
